<template>
  <div class="choose-transfer-type-card p-4">
    <div class="saved-beneficiary mt-3">
      <p class="fw-bold">2a. Saved Beneficiary</p>
      <div class="mt-2">
        <div class="d-flex flex-wrap justify-content-between">
          <div class="text-center" @click="createBeneficiaryModal = true">
            <vs-avatar circle class="m-auto" size="60">
              <template #text> + </template>
            </vs-avatar>
            <p class="mt-1 fw-bold text-sm">Add New</p>
          </div>
          <div
            v-for="(beneficiary, i) in beneficiaries"
            :key="i"
            class="text-center"
            @click="updateBeneficiaryDetails(beneficiary)"
          >
            <vs-avatar class="m-auto" circle size="60">
              <img :src="beneficiary.image" alt="" />
            </vs-avatar>
            <p class="mt-1 fw-bold text-sm text-capitalize">
              {{ beneficiary.name }}
            </p>
          </div>
        </div>
      </div>
    </div>
    <div class="fill-beneficiary mt-3">
      <p class="fw-bold">2b. Fill the beneficiary Details</p>
      <div class="form mt-2">
        <form @submit.prevent="buyAirtime">
          <div class="row">
            <div class="col-sm-12 col-md-6">
              <div class="form-group my-4">
                <label>Network</label>
                <select
                  v-model="form.network"
                  v-validate="'required'"
                  class="form-select"
                  name="Network"
                >
                  <option
                    v-for="(network, i) in networks"
                    :key="i"
                    :value="network"
                  >
                    {{ network.billername }}
                  </option>
                </select>
                <div v-show="verrors.has('Network')" class="invalid-feedback">
                  {{ verrors.first('Network') }}
                </div>
              </div>
              <div class="form-group">
                <label class="mb-2">Beneficiary Phone Number</label>
                <input
                  v-model="form.phoneNumber"
                  v-validate="'required|integer'"
                  type="text"
                  class="form-control"
                  name="Phone Number e.g 08012992121"
                />
                <div
                  v-show="verrors.has('Phone Number')"
                  class="invalid-feedback"
                >
                  {{ verrors.first('Phone Number') }}
                </div>
              </div>
              <div class="form-group">
                <label class="mb-2">Account to Debit:</label>
                <select
                  v-model="form.accountFrom"
                  v-validate="'required'"
                  class="form-select"
                  name="Account to Debit"
                >
                  <option
                    v-for="(account, i) in accounts"
                    :key="i"
                    :value="account"
                  >
                    {{ `${account.AccountType} - ${account.AccountNumber}` }}
                  </option>
                </select>
                <div
                  v-show="verrors.has('Account to Debit')"
                  class="invalid-feedback"
                >
                  {{ verrors.first('Account to Debit') }}
                </div>
              </div>
              <div class="form-group mt-3">
                <label class="mb-2">Amount (max. 20,000)</label>
                <div class="input-group">
                  <!-- <span
                    class="input-group-text border-0 text-dark fw-bold"
                    style="background: #f4f2ec"
                    >N</span
                  > -->
                  <currency-input
                    v-model="form.amount"
                    v-validate="'required|decimal'"
                    currency="NGN"
                    class="form-control"
                    type="text"
                    name="Amount"
                  />
                </div>
                <div v-show="verrors.has('Amount')" class="invalid-feedback">
                  {{ verrors.first('Amount') }}
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-6">
              <div class="form-group">
                <label class="mb-2">Enter your PIN</label>
                <input
                  v-model="form.pin"
                  v-validate="'required'"
                  type="password"
                  class="form-control"
                  name="Transaction PIN"
                />
                <div
                  v-show="verrors.has('Transaction PIN')"
                  class="invalid-feedback"
                >
                  {{ verrors.first('Transaction PIN') }}
                </div>
              </div>
              <div class="mt-3">
                <div class="d-flex justify-content-between">
                  <vs-button :loading="form.active" type="submit" class="px-5">
                    Buy
                  </vs-button>
                </div>
              </div>
            </div>
            <div class="col-sm-12 col-md-6"></div>
          </div>
        </form>
      </div>
    </div>

    <!-- Modals -->
    <!-- Successful Transfer Modal -->
    <div
      id="AirtimeSuccessModal"
      class="modal fade"
      tabindex="-1"
      data-bs-backdrop="static"
    >
      <div class="modal-dialog modal-dialog-centered">
        <div
          class="modal-content d-flex justify-content-center align-items-center"
        >
          <div class="modal-body py-5">
            <div class="text-center">
              <img
                src="@/assets/images/transfer-success-icon.png"
                alt="Transfer Successfull"
              />
            </div>
            <div class="px-5 text-center mt-3">
              <h3 class="fw-bold text-dark my-2">Airtime Top-up Successful!</h3>
              <p class="text-muted my-2 px-3">
                Congratulations, your Airtime Top-up was completed successfully!
              </p>

              <div class="mt-3">
                <div class="row">
                  <div class="col-sm-12 col-md-6 text-left">
                    <p class="text-left fw-bold">Transaction Details</p>
                    <div
                      class="bg-light py-3 px-1 text-left d-flex justify-content-between"
                      style="text-align: left !important"
                    >
                      <h5 class="fw-bold m-0">
                        {{ form.amount | formatPrice }}
                      </h5>
                      <p class="text-muted m-0" style="font-size: 10px">
                        {{ form.network && form.network.billername }}
                      </p>
                    </div>
                  </div>
                  <div class="col-sm-12 col-md-6">
                    <p class="text-left fw-bold">Beneficiary</p>

                    <div
                      class="bg-light py-3 px-2 text-left d-flex justify-content-between"
                      style="text-align: left !important"
                    >
                      <div class="">
                        <h5 class="fw-bold" style="font-size: 12px">
                          {{ form.phoneNumber }}
                        </h5>
                        <p class="text-muted m-0" style="font-size: 10px">
                          Airtel
                        </p>
                      </div>
                    </div>
                  </div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>
    </div>

    <!-- Create Corestep Account Beneficiary -->
    <vs-dialog v-model="createBeneficiaryModal" width="300px" not-center blur>
      <template #header>
        <h4 class="my-3">Create Airtime Beneficiary</h4>
      </template>
      <form
        data-vv-scope="beneficiary"
        @submit.prevent="createBeneficiary(createBeneficiaryForm)"
      >
        <div class="create-core-bank-modal">
          <div class="form-group my-4">
            <label>Network</label>
            <select
              v-model="createBeneficiaryForm.network"
              v-validate="'required'"
              class="form-select"
              name="Network"
            >
              <option
                v-for="(network, i) in networks"
                :key="i"
                :value="network"
              >
                {{ network.billername }}
              </option>
            </select>
            <div v-show="verrors.has('Network')" class="invalid-feedback">
              {{ verrors.first('Network') }}
            </div>
          </div>
          <div class="form-group my-4">
            <vs-input
              v-model="createBeneficiaryForm.phoneNumber"
              v-validate="'required|integer'"
              label-placeholder="Phone Number"
              class="w-100"
              name="Phone Number"
            />
            <div v-show="verrors.has('Phone Number')" class="invalid-feedback">
              {{ verrors.first('Phone Number') }}
            </div>
          </div>
          <div class="form-group my-4">
            <vs-input
              v-model="createBeneficiaryForm.phoneName"
              v-validate="'required'"
              label-placeholder="Name"
              class="w-100"
              name="Name"
            />
            <div v-show="verrors.has('Name')" class="invalid-feedback">
              {{ verrors.first('Name') }}
            </div>
          </div>
          <div class="d-flex my-4 w-100 justify-content-between">
            <vs-button dark transparent @click="createBeneficiaryModal = false">
              Cancel
            </vs-button>
            <vs-button
              type="submit"
              transparent
              :loading="createBeneficiaryForm.active"
            >
              Next
            </vs-button>
          </div>
        </div>
      </form>
      <template #footer> </template>
    </vs-dialog>
  </div>
</template>

<script>
export default {
  props: {
    accounts: {
      required: true,
      default: [],
    },
    networks: {
      default: [],
      required: true,
    },
  },
  data: () => ({
    createBeneficiaryModal: false,
    createBeneficiaryForm: {
      input1: '',
      active: false,
      network: {},
    },
    beneficiaries: [],
    form: {
      active: false,
      network: null,
      accountFrom: {},
    },
  }),
  created() {
    this.form.accountFrom = this.accounts[0]
    this.fetchBeneficiaries()
  },
  methods: {
    openNotification(position = null, color, message) {
      this.$vs.notification({
        progress: 'auto',
        color,
        position,
        title: message,
        text: '',
      })
    },
    buyAirtime() {
      // console.log(this.form)
      this.$validator.validateAll().then((result) => {
        if (result) {
          // console.log(this.form)
          const data = {
            amount: String(this.form.amount),
            beneficiary: this.form.phoneNumber,
            transactionPin: this.form.pin,
            billerId: this.form.network.billerid,
            accountToDebit: this.form.accountFrom.AccountNumber,
          }
          this.form.active = true
          this.$axios
            .post('/bill/airtime/buy', data)
            .then(({ data }) => {
              // console.log(data)
              this.createBeneficiaryModal = false
              this.$router.push('/user/dashboard/overview')

              this.form.active = false
              // eslint-disable-next-line
              const modal = new bootstrap.Modal(
                document.getElementById('AirtimeSuccessModal'),
                {}
              )
              modal.show()
            })
            .catch((error) => {
              this.form.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    createBeneficiary(scope) {
      this.$validator.validateAll(scope).then((result) => {
        if (result) {
          // console.log(this.form)

          const data = {
            network: this.createBeneficiaryForm.network.billername,
            phoneNumber: this.createBeneficiaryForm.phoneNumber,
            name: this.createBeneficiaryForm.phoneName,
          }
          this.createBeneficiaryForm.active = true
          this.$axios
            .post('/beneficiary/airtime', data)
            .then(({ data }) => {
              console.log(data)
              this.createBeneficiaryModal = false
              this.createBeneficiaryForm.active = false
              this.fetchBeneficiaries()
              // eslint-disable-next-line
              this.openNotification('top-left', 'success', data.message)
            })
            .catch((error) => {
              // console.log(error)
              this.createBeneficiaryForm.active = false
              if (
                error.response.status === 404 ||
                error.response.status === 400 ||
                error.response.status === 401 ||
                error.response.status === 403 ||
                error.response.status === 406 ||
                error.response.status === 409
              ) {
                // console.log(error.response.data.message)
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              } else {
                this.openNotification(
                  'top-left',
                  'danger',
                  error.response.data.message
                )
              }
            })
        }
      })
    },
    fetchBeneficiaries() {
      this.$axios
        .$get('/beneficiary/airtime?page=1&limit=5')
        .then((response) => {
          this.beneficiaries = response.payload.data
          // console.log(response)
        })
    },
    updateBeneficiaryDetails(beneficiary) {
      // console.log(beneficiary, )
      this.form.network =
        this.networks.find(
          (network) => network.billername === beneficiary.network
        ) || {}
      this.form.phoneNumber = beneficiary.phoneNumber
    },
  },
}
</script>
